%global   p_vendor      pe
%global   _name         mcollective
# VERSION is subbed out during rake package:srpm process
%global   realversion   2.7.1.1
%global   rpmversion    2.7.1.1

%if 0%{?rhel} >= 7 || 0%{?suse_version} >= 1315
%global   _with_systemd 1
%else
%global   _with_systemd 0
%endif

%if 0%{?rhel} && 0%{?rhel} < 7
%global   _old_el 1
%else
%global   _old_el 0
%endif

%if "%{dist}" == ".eos4"
%global   _eos 1
%else
%global   _eos 0
%endif

%if 0%{?suse_version} && 0%{?suse_version} < 1315
%global   _old_sles 1
%else
%global   _old_sles 0
%endif

%if 0%{?_old_el} || 0%{?_old_sles}
%global  _with_sysvinit 1
%else
%global  _with_sysvinit 0
%endif

%if "%{_os}" == "aix"
  %{!?_aix: %global _aix 1}
%endif

# Don't build the client package for el4, eos or aix
%if 0%{?rhel} >= 5 || 0%{?suse_version} >= 1110
  %global build_client  1
%else
  %global build_client  0
%endif

# Added macros for AIX
%if 0%{?_aix}
%define   _sysconfdir   /etc
%define   _initrddir    %{_sysconfdir}/rc.d/init.d
%define   __patch       /opt/freeware/bin/patch
%define   __install     /opt/freeware/bin/install
%endif

%if 0%{?p_vendor:1}
    %global name_prefix      %{p_vendor}-

    # The %{!?foo: ...} idiom is needed, because the spec gets re-evaluated for
    # each package that is built.  This really messes with things that are only
    # supposed to be evaluated at "definition time".

    # Grab the "real" directories so we can reference the system's files.
    %{!?_real_initrddir:     %global _real_initrddir     %{_initrddir}}
    %{!?_real_localstatedir: %global _real_localstatedir %{_localstatedir}}
    %{!?_real_sysconfdir:    %global _real_sysconfdir    %{_sysconfdir}}

    # Use the alternate locations for things.
    %global _initrddir       %{_real_initrddir}
    %global _localstatedir   %{_real_localstatedir}
    %global _sysconfdir      %{_real_sysconfdir}/puppetlabs

    # Override the _prefix last, so we can get the _real_* locations.
    %{!?_orig_prefix:        %global _orig_prefix       %{_prefix}}
    %global                 _prefix /opt/puppet
%endif

%if 0%{?suse_version}
  %global _libexecdir      %{_prefix}/libexec
%endif

%if 0%{?_eos}
  %global _sysconfdir      /persist/sys/etc/puppetlabs
  # (ND-107) Use SysV init rather than ProcMgr
  %global _initrddir       /etc/rc.d/init.d
%endif

%define ruby    %{_bindir}/ruby
%global   ruby_libdir   %(PATH=/opt/puppet/bin:$PATH; ruby -rrbconfig -e "puts RbConfig::CONFIG['sitelibdir']")

Name:           %{?name_prefix}%{_name}
Version:        %{rpmversion}
Release:        1.pe%{?dist}
Summary:        Application Server for hosting Ruby code on any capable middleware
Group:          System Environment/Daemons
License:        PL Commercial
Packager:       Puppet Labs <info@puppetlabs.com>
Vendor:         Puppet Labs
URL:            http://www.puppetlabs.com/%{name}
Source0:        http://puppetlabs.com/downloads/%{name}/%{name}-%{realversion}.tar.gz
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  %{?name_prefix}ruby
BuildRequires:  %{?name_prefix}ruby-stomp
%if 0%{?_aix}
BuildRequires:  sed
BuildRequires:  coreutils, binutils
%endif

Requires:       %{?name_prefix}%{_name}-common = %{version}-%{release}
Requires:       %{?name_prefix}ruby
Requires:       %{?name_prefix}ruby-stomp

%if 0%{?suse_version}
BuildRequires:  procps
Requires:       procps
Requires:       aaa_base
%endif

%if 0%{?rhel} && 0%{?_with_systemd}
# Required for %%post, %%preun, %%postun
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: systemd
%endif

%if 0%{?suse_version} && 0%{?_with_systemd}
BuildRequires:  systemd
%{?systemd_requires}
%endif

%if 0%{?_old_el}
# Required for %%post and %%preun
Requires:       chkconfig
# Required for %%preun and %%postun
Requires:       initscripts
%endif

%if ! 0%{?_aix}
Requires:       logrotate
%endif

# Services run via ProcMgr for EOS
%if 0%{?_eos}
Requires:       ProcMgr
%endif

Provides:       %{?name_prefix}%{_name} = %{version}-%{release}

%description
The Marionette Collective:

Server for the mcollective Application Server


%package common
Summary:        Common libraries for the mcollective clients and servers
Group:          System Environment/Libraries
Vendor:         Puppet Labs
Requires:       %{?name_prefix}ruby
Requires:       %{?name_prefix}ruby-stomp
Provides:       %{?name_prefix}%{_name}-common = %{version}-%{release}

%description common
The Marionette Collective:

Common libraries for the mcollective clients and servers

%if 0%{?build_client}
%package client
Summary:        Client tools for the mcollective Application Server
Group:          Applications/System
Vendor:         Puppet Labs
Requires:       %{?name_prefix}%{_name}-common = %{version}-%{release}
Requires:       %{?name_prefix}ruby
Requires:       %{?name_prefix}ruby-stomp
Provides:       %{?name_prefix}%{_name}-client = %{version}-%{release}

%description client
The Marionette Collective:

Client tools for the mcollective Application Server
%endif

%prep
export PATH=/opt/puppet/bin:/opt/freeware/bin:$PATH
%setup -q -n %{name}-%{realversion}

%build

%pre
# Stop mcollective if it's running
%if ! 0%{?_aix}
if /usr/bin/pgrep mcollectived >/dev/null ; then
  /sbin/service %{name} stop >/dev/null 2>&1 || :
fi
if /usr/bin/pgrep mcollectived >/dev/null ; then
  /usr/bin/pkill -9 mcollectived >/dev/null || :
  if [ -f /var/run/%{name}.pid ] ; then
  rm -f /var/run/%{name}.pid >/dev/null
  fi
fi
%endif

%install
export PATH=/opt/puppet/bin:/opt/freeware/bin:$PATH

rm -rf %{buildroot}

%{ruby} install.rb \
    --destdir=%{buildroot} \
    --no-rdoc \
    --sitelibdir=%{ruby_libdir} \
    --plugindir=%{_libexecdir}/%{_name} \
    --configdir=%{_sysconfdir}/%{_name}


%{__install} -d -m0755  %{buildroot}%{_sysconfdir}/%{_name}/plugin.d
%{__install} -d -m0755  %{buildroot}%{_sysconfdir}/%{_name}/ssl/clients
%{__install} -d -m0755  %{buildroot}%{_localstatedir}/log/%{name}
%if 0%{?_old_sles}
%{__install} -d -m0755  %{buildroot}%{_initrddir}
%{__install} -m0755 ext/redhat/%{name}.init.suse %{buildroot}%{_initrddir}/%{name}
%endif
%if 0%{?_with_systemd}
%{__install} -d -m0755  %{buildroot}%{_unitdir}
%{__install} -m0644 ext/redhat/%{name}.service %{buildroot}%{_unitdir}/
%endif
%if 0%{?_old_el} || 0%{?_eos}
%{__install} -d -m0755  %{buildroot}%{_initrddir}
%{__install} -m0755 ext/redhat/%{name}.init-rh %{buildroot}%{_initrddir}/%{name}
%endif
%if 0%{?_eos}
%{__install} -d -m0755  %{buildroot}%{_initrddir}
# EOS 4.12 is Fedora 14 based so we use the RH init script
%{__install} -m0755 ext/redhat/%{name}.init-rh %{buildroot}%{_initrddir}/%{name}
%endif

# Modify all ruby utilities to use PE ruby
for file in `find %{buildroot} -type f`; do
    sed -i -e '1s,^#!.*ruby$,#!/opt/puppet/bin/ruby,' $file
done

# install logrotate directives.
install -d %{buildroot}/%{_real_sysconfdir}/logrotate.d

%if ! 0%{?_aix} && 0%{?_with_sysvinit}
install -m644 ext/redhat/%{name}-sysv.logrotate \
    %{buildroot}/%{_real_sysconfdir}/logrotate.d/%{name}
%endif

%if ! 0%{?_aix} && 0%{?_with_systemd}
install -m644 ext/redhat/%{name}-systemd.logrotate \
    %{buildroot}/%{_real_sysconfdir}/logrotate.d/%{name}
%endif

%if 0%{?_eos}
install -m644 ext/eos/%{name}.logrotate \
    %{buildroot}/%{_real_sysconfdir}/logrotate.d/%{name}
%endif

%if 0%{?_with_sysvinit}
# sysconfig
mkdir -p  %{buildroot}%{_real_sysconfdir}/sysconfig/
install -p -m644 ext/redhat/%{name}.sysconfig %{buildroot}%{_real_sysconfdir}/sysconfig/%{name}
%endif

# rpmlint cleanups
find  %{buildroot} -name .gitignore | xargs rm -f
find  %{buildroot} -name .keep | xargs rm -f

%if ! 0%{?build_client}
# Clean up the mcollective-client files on el4 and aix because we aren't
# building the client subpackage
rm -rf %{buildroot}%{_bindir}/mco \
       %{buildroot}%{_sysconfdir}/%{_name}/client.cfg \
       %{buildroot}%{_sysconfdir}/%{_name}/rpc-help.erb \
       %{buildroot}%{_libexecdir}/%{_name}/%{_name}/application/* \
       %{buildroot}%{_libexecdir}/%{_name}/%{_name}/pluginpackager/* \
       %{buildroot}%{_libexecdir}/%{_name}/%{_name}/aggregate/*
%endif

%clean
rm -rf %{buildroot}

%post
%if 0%{?_aix}
mkssys -p %{_bindir}/ruby -s %{name} -u root -a '%{_sbindir}/mcollectived --config=%{_sysconfdir}/%{_name}/server.cfg ' -w 7 -S -n 15 -f 9 > /dev/null  2>&1 || :
%endif
%if 0%{?rhel} && 0%{?_with_systemd}
%systemd_post %{name}.service
%endif
%if 0%{?suse_version} && 0%{?_with_systemd}
%service_add_post %{name}.service
%endif
%if 0%{?_with_sysvinit}
/sbin/chkconfig --add %{name} || :
%endif
%if 0%{?_eos}
/usr/bin/chkagent --add %{name} || :
/sbin/service ProcMgr reload || :
%endif

%postun
%if 0%{?rhel} && 0%{?_with_systemd}
%systemd_postun_with_restart %{name}.service 
%endif
%if 0%{?suse_version} && 0%{?_with_systemd}
%service_del_postun %{name}.service
%endif

%if 0%{?_with_sysvinit}
if [ "${1}" -ge 1 ]; then
    /sbin/service %{name} condrestart &>/dev/null || :
fi
%endif
%if 0%{?_aix}
if [ "${1}" -ge 1 ]; then
    stopsrc -s %{name} > /dev/null 2>&1  || true
    sleep 2
    startsrc -s %{name} > /dev/null 2>&1  || true
fi
%endif
%if 0%{?_eos}
if [ "${1}" -ge 1 ]; then
    /sbin/service ProcMgr reload || :
fi
%endif

%preun
%if 0%{?rhel} && 0%{?_with_systemd}
%systemd_preun %{name}.service 
%endif
%if 0%{?suse_version} && 0%{?_with_systemd}
%service_del_preun %{name}.service
%endif
%if 0%{?_with_sysvinit}
if [ "${1}" = 0 ] ; then
    /sbin/service %{name} stop > /dev/null 2>&1
    /sbin/chkconfig --del %{name} || :
fi
%endif
%if 0%{?_aix}
if [ "${1}" = 0 ] ; then
    # Stop
    stopsrc -s %{name} > /dev/null 2>&1
    # Unregister
    rmssys -s %{name} || true
fi
%endif
%if 0%{?_eos}
if [ "${1}" = 0 ] ; then
    /usr/bin/chkagent --del %{name} || :
    /sbin/service ProcMgr reload || :
fi
%endif

%files common
%defattr(-, root, root)
%{ruby_libdir}/mcollective.rb
%{ruby_libdir}/mcollective
%{_libexecdir}/%{_name}/%{_name}/agent/*
%{_libexecdir}/%{_name}/%{_name}/audit/*
%{_libexecdir}/%{_name}/%{_name}/connector/*
%{_libexecdir}/%{_name}/%{_name}/data/*
%{_libexecdir}/%{_name}/%{_name}/facts/*
%{_libexecdir}/%{_name}/%{_name}/registration/*
%{_libexecdir}/%{_name}/%{_name}/security/*
%{_libexecdir}/%{_name}/%{_name}/validator/*
%{_libexecdir}/%{_name}/%{_name}/discovery/*
%config(noreplace)%{_sysconfdir}/%{_name}/data-help.erb
%config(noreplace)%{_sysconfdir}/%{_name}/discovery-help.erb
%config(noreplace)%{_sysconfdir}/%{_name}/metadata-help.erb

%if 0%{?build_client}
%files client
%defattr(-, root, root, 0755)
%attr(0755, root, root)%{_bindir}/mco
%config(noreplace)%{_sysconfdir}/%{_name}/client.cfg
%{_sysconfdir}/%{_name}/rpc-help.erb
%{_libexecdir}/%{_name}/%{_name}/application/*
%{_libexecdir}/%{_name}/%{_name}/pluginpackager/*
%{_libexecdir}/%{_name}/%{_name}/aggregate/*
%endif

%files
%defattr(-, root, root, 0755)
%attr(0755, root, root)%{_sbindir}/mcollectived
%if 0%{?_with_systemd}
%{_unitdir}/%{name}.service
%endif
%if 0%{?_with_sysvinit}
%{_initrddir}/%{name}
%{_real_sysconfdir}/sysconfig/%{name}
%endif
%if 0%{?_eos}
%{_initrddir}/%{name}
%endif
%config(noreplace)%{_sysconfdir}/%{_name}/server.cfg
%config(noreplace)%{_sysconfdir}/%{_name}/facts.yaml
%dir %{_sysconfdir}/%{_name}/ssl/clients
%config(noreplace)%{_sysconfdir}/%{_name}/plugin.d
%dir %{_localstatedir}/log/%{name}
%if ! 0%{?_aix}
%config(noreplace) %{_real_sysconfdir}/logrotate.d/%{name}
%endif

%changelog
* Thu Aug 04 2016 Puppet Labs Release <info@puppetlabs.com> -  2.7.1.1-1
- Build for 2.7.1.1

* Tue Nov 03 2009 R.I.Pienaar <rip@devco.net>
- First release
